# Generated by rust2rpm
%bcond_without check

# Not interested in packaging lib
# stratisd is supposed to be daemon used through dbus
%global __cargo_is_lib() false

Name:           stratisd
Version:        1.0.0
Release:        1%{?dist}
Summary:        Daemon that manages block devices to create filesystems

License:        MPLv2.0
URL:            https://github.com/stratis-storage/stratisd
Source0:        %{url}/archive/v%{version}/%{name}-%{version}.tar.gz

ExclusiveArch:  %{rust_arches}

BuildRequires:  rust-packaging
# [dependencies]
BuildRequires:  (crate(byteorder) >= 1.0.0 with crate(byteorder) < 2.0.0)
BuildRequires:  (crate(chrono) >= 0.4.0 with crate(chrono) < 0.5.0)
BuildRequires:  (crate(clap) >= 2.0.0 with crate(clap) < 3.0.0)
BuildRequires:  (crate(crc) >= 1.0.0 with crate(crc) < 2.0.0)
BuildRequires:  (crate(dbus) >= 0.6.1 with crate(dbus) < 0.7.0)
BuildRequires:  (crate(devicemapper) >= 0.26.0 with crate(devicemapper) < 0.27.0)
BuildRequires:  (crate(env_logger) >= 0.5.0 with crate(env_logger) < 0.6.0)
BuildRequires:  (crate(error-chain) >= 0.12.0 with crate(error-chain) < 0.13.0)
BuildRequires:  (crate(lazy_static) >= 1.0.0 with crate(lazy_static) < 2.0.0)
BuildRequires:  (crate(libc) >= 0.2.36 with crate(libc) < 0.3.0)
BuildRequires:  (crate(libmount) >= 0.1.10 with crate(libmount) < 0.2.0)
BuildRequires:  (crate(libudev) >= 0.2.0 with crate(libudev) < 0.3.0)
BuildRequires:  (crate(log) >= 0.4.0 with crate(log) < 0.5.0)
BuildRequires:  (crate(macro-attr) >= 0.2.0 with crate(macro-attr) < 0.3.0)
BuildRequires:  (crate(nix) >= 0.11.0 with crate(nix) < 0.12.0)
BuildRequires:  (crate(rand) >= 0.4.0 with crate(rand) < 0.5.0)
BuildRequires:  (crate(serde) >= 1.0.0 with crate(serde) < 2.0.0)
BuildRequires:  (crate(serde_derive) >= 1.0.0 with crate(serde_derive) < 2.0.0)
BuildRequires:  (crate(serde_json) >= 1.0.0 with crate(serde_json) < 2.0.0)
BuildRequires:  (crate(tempfile) >= 3.0.1 with crate(tempfile) < 4.0.0)
BuildRequires:  (crate(timerfd) >= 1.0.0 with crate(timerfd) < 2.0.0)
BuildRequires:  ((crate(uuid) >= 0.6.0 with crate(uuid) < 0.7.0) with crate(uuid/serde) with crate(uuid/v4))
BuildRequires:  (crate(walkdir) >= 2.2.5 with crate(walkdir) < 3.0.0)
%if %{with check}
# [dev-dependencies]
BuildRequires:  (crate(either) >= 1.1.0 with crate(either) < 2.0.0)
BuildRequires:  (crate(loopdev) >= 0.2.0 with crate(loopdev) < 0.3.0)
BuildRequires:  (crate(quickcheck) >= 0.6.0 with crate(quickcheck) < 0.7.0)
%endif
BuildRequires:  %{_bindir}/a2x
BuildRequires:  systemd

%{?systemd_requires}
Requires:       xfsprogs
Requires:       device-mapper-persistent-data

%description
%{summary}.

%prep
%autosetup -p1
%cargo_prep

%build
%cargo_build
%cargo_build -n
a2x -f manpage docs/stratisd.txt

%install
%cargo_install
# Daemon should be really private
mkdir -p %{buildroot}%{_libexecdir}
mv %{buildroot}%{_bindir}/stratisd %{buildroot}%{_libexecdir}/stratisd

%cargo_install -n
# Init version should be in sbin
mkdir -p %{buildroot}%{_sbindir}
mv %{buildroot}%{_bindir}/stratisd %{buildroot}%{_sbindir}/stratisd-init

%{__install} -Dpm0644 -t %{buildroot}%{_datadir}/dbus-1/system.d stratisd.conf
%{__install} -Dpm0644 -t %{buildroot}%{_mandir}/man8 docs/stratisd.8
%{__install} -Dpm0644 -t %{buildroot}%{_unitdir} stratisd.service

%if %{with check}
%check
%cargo_test -- -- --skip real_ --skip loop_ --skip travis_ --skip test_buffering
%endif

%post
%systemd_post stratisd.service

%preun
%systemd_preun stratisd.service

%postun
%systemd_postun_with_restart stratisd.service

%files
%license LICENSE
%doc README.md
%{_libexecdir}/stratisd
%{_sbindir}/stratisd-init
%dir %{_datadir}/dbus-1
%{_datadir}/dbus-1/system.d/stratisd.conf
%{_mandir}/man8/stratisd.8*
%{_unitdir}/stratisd.service

%changelog
* Thu Sep 27 2018 Igor Gnatenko <ignatenkobrain@fedoraproject.org> - 1.0.0-1
- Initial package
